-- sh_bh_apartments.lua: Sommerset Apartments

-- Cutscene crash fixes by IdolNinja
-- 3/12/2011

-- Checkpoint Variables [nclok1405]
g_checkpoint = MISSION_START_CHECKPOINT	-- Checkpoint name [nclok1405]
g_is_restart = false	-- true if restarting [nclok1405]

CHECKPOINT_START = MISSION_START_CHECKPOINT
CHECKPOINT_AREA1 = "CHECKPOINT_AREA1"	-- Area 1 completed [nclok1405]
CHECKPOINT_AREA2 = "CHECKPOINT_AREA2"	-- Area 2 completed [nclok1405]
CHECKPOINT_VAN = "van"

--Tables
targets =	{
			"sh_bh_apartments_$c001","sh_bh_apartments_$c001 (0)","sh_bh_apartments_$c001 (1)",
			"sh_bh_apartments_$c002","sh_bh_apartments_$c002 (0)","sh_bh_apartments_$c002 (1)",
			"sh_bh_apartments_$c004","sh_bh_apartments_$c004 (0)","sh_bh_apartments_$c004 (1)"
				}

waveOne = {"sh_bh_apartments_$cW00","sh_bh_apartments_$cW01","sh_bh_apartments_$cW02","sh_bh_apartments_$cW03","sh_bh_apartments_$cW00 (0)","sh_bh_apartments_$cW01 (0)","sh_bh_apartments_$cW02 (0)","sh_bh_apartments_$cW03 (0)"}
waveTwo = {"sh_bh_apartments_$cW01 (1)","sh_bh_apartments_$cW02 (1)","sh_bh_apartments_$cW03 (1)"}

groupone = {"sh_bh_apartments_$c001 (1)", "sh_bh_apartments_$c001 (0)", "sh_bh_apartments_$c001"} 
grouptwo = {"sh_bh_apartments_$c002", "sh_bh_apartments_$c002 (0)", "sh_bh_apartments_$c002 (1)"}
groupfour = {"sh_bh_apartments_$c004", "sh_bh_apartments_$c004 (0)", "sh_bh_apartments_$c004 (1)"}
area_done = {false, false, false}
areas =	{"sh_bh_apartments_$tgoto_one", "sh_bh_apartments_$tgoto_two", "sh_bh_apartments_$tgoto_four"}
groups = {groupone,grouptwo, groupfour}
group_names = {"sh_bh_apartments_$Gone", "sh_bh_apartments_$GTwo", "sh_bh_apartments_$Gfour"}
door_triggers = {"sh_bh_apartments_$tDoor_one", "sh_bh_apartments_$tDoor_two", "sh_bh_apartments_$tDoor_three"}

-- door variables and table
DOOR_ONE="sh_bh_apartments_APT083_P_MM_Door010"
DOOR_TWO="sh_bh_apartments_APT083_G_MM_Door010"
DOOR_THREE="sh_bh_apartments_APT083_D_moverDoor010"
doors={DOOR_ONE,DOOR_TWO,DOOR_THREE}
--Globals
door_triggers_size = sizeof_table(door_triggers)
targets_total = 0
targets_left = sizeof_table(areas)
in_area = false
in_area_remote = false
waveOne_total = sizeof_table(waveOne)
waveTwo_total = sizeof_table(waveTwo)
groupone_total = sizeof_table(groupone)
groupone_count = 0
grouptwo_total = sizeof_table(grouptwo)
groupfour_total = sizeof_table(groupfour)
--groupfive_total = sizeof_table(groupfive)
grouptwo_count = 0
groupfour_count = 0
groupfive_count = 0
areas_total = sizeof_table(areas)
areas_count = 0
groups_total = sizeof_table(groups)
group_names_total = sizeof_table(group_names)
groups_count = 0
areatracker = 0
groups_size = {groupone_total, grouptwo_total, groupfour_total}
groups_count = {groupone_count, grouptwo_count, groupfour_count} 
temp_point = ""
closest_point = 0
operations_done = false
methvan_active = false
nav_set = false
nav_thread_handle =""
current_waypoint = ""
methvan_hud_active = false -- true if methvan's health is on display [nclok1405]

-- CUTSCENES --
-- Added by IdolNinja. These variables are used in the script for the cutscenes for stability instead of calling them directly

	CUTSCENE_IN = 		"sh_bh_apartmentsct2"
	MISSION_NAME =		"sh_bh_apartments"

function sh_bh_apartments_start(checkpoint, is_restart)

	set_mission_author("David Bowring")
	notoriety_set_max("brotherhood", 2)
	notoriety_set_min("brotherhood", 2)
	notoriety_set_max("police", 0)

	if (checkpoint == CHECKPOINT_START) then
		mission_start_fade_out()
		teleport_coop("sr2_city_$sh_bh_apartments","sh_bh_apartments_$nplayer2")
		group_create("sh_bh_apartments_$Gguards")
		if (not is_restart) then
			cutscene_play(CUTSCENE_IN)
		end
		sh_bh_apartments_one()
	elseif (checkpoint == CHECKPOINT_AREA1) then
		group_create("sh_bh_apartments_$Gguards")
		area_done[1] = true
		areas_count = 1
		fade_in(1)
		sh_bh_apartments_one()
	elseif (checkpoint == CHECKPOINT_AREA2) then
		group_create("sh_bh_apartments_$Gguards")
		area_done[1] = true
		area_done[2] = true
		areas_count = 2
		fade_in(1)
		sh_bh_apartments_one()
	elseif (checkpoint == CHECKPOINT_VAN) then
		fade_in(1)
		sh_bh_apartments_methvan()
	end
end	


function sh_bh_apartments_one()
	notoriety_force_no_spawn("brotherhood", true)
	for i = 1, areas_total, 1 do
		if (area_done[i] == false) then
			marker_add_navpoint(door_triggers[i],MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
			on_trigger("sh_bh_apartments_in_area", areas[i])
			--on_trigger("sh_bh_apartments_door_triggers", door_triggers[i])
			trigger_enable(areas[i], true)
			trigger_enable(door_triggers[i], true)
			door_lock(doors[i],true)
		end
	end		
	nav_thread_handle = thread_new("sh_bh_apartments_nearest")
	objective_text(0, "sh_bh_apartments_ltcount", areas_count, areas_total) --"Operations Left: %s" <-- Must Change
	mission_start_fade_in()
end


function sh_bh_apartments_door_triggers(char, trigger_name)
	marker_remove_trigger(trigger_name)
	trigger_enable(trigger_name, false)
end

function sh_bh_apartments_methvan()
	methvan_active = true
	mission_debug("Meth van activate")	
	objective_text_clear(0)
	for i =1, group_names_total, 1 do
		if group_is_loaded(group_names[i]) then
			release_to_world(group_names[i])
		end
	end

	mission_help_table("sh_bh_apartments_instruct_three")

	if  not group_is_loaded("sh_bh_apartments_$Gseven") then
		group_create("sh_bh_apartments_$Gseven", true)
	end

	vehicle_enter_group_teleport({"sh_bh_apartments_$c007", "sh_bh_apartments_$c007 (0)"}, "sh_bh_apartments_$vCar")
	set_unjackable_flag("sh_bh_apartments_$vCar", true)
	on_damage("sh_bh_apartments_methvan_damage", "sh_bh_apartments_$vCar", .90) 
	on_vehicle_destroyed("sh_bh_apartments_methvan_death", "sh_bh_apartments_$vCar")
	vehicle_suppress_npc_exit("sh_bh_apartments_$vCar", true) 

	marker_add_vehicle("sh_bh_apartments_$vCar", MINIMAP_ICON_KILL, INGAME_EFFECT_VEHICLE_KILL)
	mission_waypoint_add("sh_bh_apartments_$vCar", SYNC_ALL)

	vehicle_pathfind_to("sh_bh_apartments_$vCar", "sh_bh_apartments_$pathcrack", false, true) --nav mesh = traffic laws
	vehicle_pathfind_to("sh_bh_apartments_$vCar", "sh_bh_apartments_$pathcrack2", false, true)
end

function sh_bh_apartments_methvan_damage(car)
	if MMC_MORE_HUD and (not methvan_hud_active) then
		damage_indicator_on(0, "sh_bh_apartments_$vCar", 0, "", get_max_hit_points("sh_bh_apartments_$vCar"), SYNC_ALL)
		methvan_hud_active = true
	end

	vehicle_flee(car)
end



function sh_bh_apartments_methvan_death(car)
	on_vehicle_destroyed("", "sh_bh_apartments_$vCar")
	marker_remove_vehicle(car)
	--delay(3)
	sh_bh_apartments_end()
end


function sh_bh_apartments_in_area( triggerer_name, trigger_name )
	
	objective_text_clear(0) --Clear out the "Shop Owners Left:" line
	mission_help_table("sh_bh_apartments_instruct_one") --Destroy the storefronts to get the shopkeepers to come out
	in_area = true
	thread_kill(nav_thread_handle)

	if triggerer_name == REMOTE_PLAYER then
		in_area_remote = true
	end


	for i = 1, areas_total, 1 do			
		if area_done[i] == false then
			marker_remove_navpoint(areas[i])		--remove area markers
			marker_remove_navpoint(door_triggers[i])
		end
	end
	
	for i = 1, areas_total, 1 do
		if (areas[i] == trigger_name) and (area_done[i] == false) then
			areatracker = i
			door_lock(doors[i],false)
			on_trigger("", trigger_name)
			mission_debug("Player enters area",5)
			mission_waypoint_remove(SYNC_ALL)				
			objective_text(0, "sh_bh_apartments_instruct_two", groups_count[areatracker], groups_size[areatracker])
			group_create(group_names[areatracker], true)

			for i = 1, groups_size[areatracker], 1 do					
				marker_add_npc(groups[areatracker][i], MINIMAP_ICON_KILL, INGAME_EFFECT_KILL)
				on_death("sh_bh_apartments_killcount_targets", groups[areatracker][i])
			end		
			mission_debug( "created group "..group_names[areatracker].."", 15 )
		end

		if (i ~= areatracker) and (area_done[i] ~= true) then
			trigger_enable(areas[i], false)		
		end

	end

end




function sh_bh_apartments_killcount_targets(char)	
	groups_count[areatracker] = groups_count[areatracker]+1
	
	


		
	
	marker_remove_npc(char)
	objective_text(0, "sh_bh_apartments_instruct_two", groups_count[areatracker], groups_size[areatracker])
	on_death("", char)
	release_to_world(char)	
	mission_debug("kill called="..char)
	if (groups_count[areatracker] == groups_size[areatracker]) then
		areas_count = areas_count + 1
		area_done[areatracker] = true
		in_area = false
		objective_text_clear(0)
		if areas_count == areas_total then
			in_area = false
			operations_done = true
			mission_debug("areas done="..char)
			mission_set_checkpoint(CHECKPOINT_VAN)
			sh_bh_apartments_methvan()
			--return
			--sh_bh_apartments_end()
		elseif methvan_active == false then
			nav_set= false
			nav_thread_handle = thread_new("sh_bh_apartments_nearest")
		end

		-- Area Checkpoints [nclok1405]
		if (areas_count == 1) and (areatracker == 1) and (area_done[1] == true) and (area_done[2] == false) and (area_done[3] == false) then
			mission_set_checkpoint(CHECKPOINT_AREA1)
		elseif (areas_count == 2) and (areatracker == 2) and (area_done[2] == true) and (area_done[2] == true) and (area_done[3] == false) then
			mission_set_checkpoint(CHECKPOINT_AREA2)
		end

		delay(1)
		for i = 1, areas_total, 1 do				
			if (area_done[i] == false) then
				marker_add_navpoint(door_triggers[i],MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
				--marker_add_navpoint(areas[i],MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
				on_trigger("sh_bh_apartments_in_area", areas[i])
				trigger_enable(areas[i], true)				
				objective_text(0, "sh_bh_apartments_ltcount", areas_count, areas_total)
			end
		end		
	end

	if	areas_count == 1 then
		notoriety_force_no_spawn("brotherhood", false) 
	end	

end


function sh_bh_apartments_nearest()	
		mission_debug("nearest Called")
		objective_text_clear(0)
		if operations_done==false and methvan_active == false then
		mission_help_table("MSN_SH_BH_APARTMENTS_INSTRUCT_INITIAL") -- "Kill all the BH LTs running each operation!"
		end
		while (in_area == false and methvan_active == false) do
		mission_debug("near loop")
		delay(.5)
		sh_bh_apartments_get_closest_nav_to_char( areas, LOCAL_PLAYER )
		end
end

function sh_bh_apartments_get_closest_nav_to_char( navpoint_names, character_name )
   local closest_nav_name = navpoint_names[1]
   local closest_dist = 2000 --get_dist_char_to_nav( character_name, navpoint_names[1] )
   local closest_index = 0
	local cur_dist = 0
	local new_nav_required = false

	for nav_index, nav_name in pairs( navpoint_names ) do
		 
			if area_done[nav_index] == false then
			cur_dist = get_dist_char_to_nav( character_name, nav_name )
			--mission_debug( "nav_name = "..nav_name..", cur_dist = "..cur_dist, 15 )
			
				if ( cur_dist < closest_dist ) then
					closest_nav_name = nav_name
					closest_dist = cur_dist
					closest_index = nav_index
					new_nav_required = true
				end
			
			end
	end

	if closest_index == 0 then
		return
	end

	--mission_debug( "nav_name = "..closest_nav_name..", cur_dist = "..cur_dist, 15 )
	
	
	if current_waypoint ~= closest_nav_name then
	nav_set = true
	mission_debug("waypoint set")
	current_waypoint=closest_nav_name
	mission_waypoint_add(closest_nav_name, SYNC_ALL)
	end
	 
   --return closest_nav_name, closest_index, closest_dist
end


		





function sh_bh_apartments_timer(time_left)
end





-- Unused [nclok1405]
function sh_bh_apartments_two()
end


function sh_bh_apartments_back()
end


	
function sh_bh_apartments_leave()
end



function sh_bh_apartments_cleanup()
	for i = 1, areas_total, 1 do
		marker_remove_navpoint(door_triggers[i])
		on_trigger("", areas[i])
		--on_trigger("sh_bh_apartments_door_triggers", door_triggers[i])
		trigger_enable(areas[i], false)
		trigger_enable(door_triggers[i],false)
		door_lock(doors[i],false)
	end
	marker_remove_vehicle("sh_bh_apartments_$vCar")
	damage_indicator_off(0)
end


function sh_bh_apartments_failure()
end

function sh_bh_apartments_success()
	--mission_end_success(MISSION_NAME)
end

function sh_bh_apartments_end()
	delay(3)
	mission_end_success(MISSION_NAME)
end
