-- sh_bh_docks.lua: Poseidon Alley Docks

-- Cutscene crash fixes by IdolNinja
-- 3/12/2011

DEBUG_GHOSTTOWN = false	-- Ghost Town mode (Disable 99% of random spawns) [nclok1405]

-- Checkpoint Variables [nclok1405]
g_checkpoint = MISSION_START_CHECKPOINT	-- Checkpoint name [nclok1405]
g_is_restart = false	-- true if restarting [nclok1405]

-- Checkpoints [nclok1405]
CHECKPOINT_START = MISSION_START_CHECKPOINT
CHECKPOINT_ENTER = "CHECKPOINT_ENTER"	-- Truck entered
CHECKPOINT_GETOUT = "CHECKPOINT_GETOUT"	-- End of path

-- Vehicle Names [nclok1405]
HIJACK_TRUCK = "sh_bh_docks_$v000"	-- The truck player needs to enter
CONVOY_TRUCK = "sh_bh_docks_$v001"	-- The truck player needs to follow

-----tables
hijack_guards = {"sh_bh_docks_$c000", "sh_bh_docks_$c001", "sh_bh_docks_$c002", "sh_bh_docks_$c003"}	-- The guards around the player truck [nclok1405]

convoy={ "sh_bh_docks_$c004", "sh_bh_docks_$c004 (0)", "sh_bh_docks_$c004 (1)", "sh_bh_docks_$c004 (2)", "sh_bh_docks_$c004 (3)", "sh_bh_docks_$c004 (4)", "sh_bh_docks_$c004 (5)", "sh_bh_docks_$c004 (6)", "sh_bh_docks_$c005", "sh_bh_docks_$c005 (0)", "sh_bh_docks_$c005 (1)", "sh_bh_docks_$c005 (2)"} 
convoy_one = { "sh_bh_docks_$c004", "sh_bh_docks_$c004 (0)", "sh_bh_docks_$c004 (1)","sh_bh_docks_$c004 (2)"}
convoy_one_navs = {"sh_bh_docks_$nconvoy_one_path_find", "sh_bh_docks_$nconvoy_one_path_find (0)", "sh_bh_docks_$nconvoy_one_path_find (1)", "sh_bh_docks_$nconvoy_one_path_find (2)"}
hijackpeds={{"sh_bh_docks_$c000", 1},
				{"sh_bh_docks_$c001", 1},
				{"sh_bh_docks_$c002", 2},
				{"sh_bh_docks_$c003", 2}}
buyers= {"sh_bh_docks_$c006 (0)", "sh_bh_docks_$c006", "sh_bh_docks_$c006 (1)", "sh_bh_docks_$c006 (2)", "sh_bh_docks_$c006 (3)"}
follow_car={"sh_bh_docks_$c004", "sh_bh_docks_$c004 (0)", "sh_bh_docks_$c004 (1)", "sh_bh_docks_$c004 (2)"}
action={{"sh_bh_docks_$c004 (2)" , 1},
		  {"sh_bh_docks_$c004 (3)" , 1}, 
		  {"sh_bh_docks_$c004 (4)" , 1},
		  {"sh_bh_docks_$c004 (5)" , 1}, 
		  {"sh_bh_docks_$c004 (6)" , 2},
		  {"sh_bh_docks_$c005" , 2},
		  {"sh_bh_docks_$c005 (0)", 2}, 
		  {"sh_bh_docks_$c005 (1)" , 3}, 
		  {"sh_bh_docks_$c005 (2)" , 3}} 

thread_handles = {"", "", "", ""}
  
---variables
hijack_guards_total = sizeof_table( hijack_guards )
convoy1=false
convoy2=false
convoy3=false
incar=false
incar_timer=true
incar_timer_coop=true
convoy_count = 0
convoy_total = sizeof_table( convoy )
hijackpeds_count=0
hijackpeds_total=sizeof_table( hijackpeds )
buyers_count=0
times_damaged = 0
follow_count = sizeof_table( follow_car )
action_total = sizeof_table( action )
convoy_one_total = sizeof_table ( convoy_one )
message_playing = false


-- CUTSCENES --
-- Added by IdolNinja. These variables are used in the script for the cutscenes for stability instead of calling them directly

	CUTSCENE_IN = 		"sh_bh_docksct1"
	MISSION_NAME =		"sh_bh_docks"
	MISSION_FAIL_GETBACK =	"MSN_SH_BH_DOCKS_GETBACK_FAIL"
	MISSION_FAIL =		"sh_bh_docks_fail"
	MISSION_FAIL_THREE = 	"sh_bh_docks_fail_three"
	MISSION_FAIL_FOUR =	"sh_bh_docks_fail_four"
 

function sh_bh_docks_start(checkpoint, is_restart)
	-- Remember the checkpoint and restart values [nclok1405]
	g_checkpoint = checkpoint
	g_is_restart = is_restart

	if DEBUG_GHOSTTOWN then
		spawning_pedestrians(false, false)
		spawning_vehicles(false)
		set_traffic_density(0)
		set_ped_density(0)
	end

	notoriety_set_max("police", 0)	-- No police
	ambient_gang_spawn_enable(false)	-- Do not spawn random Brotherhoods

	set_mission_author("David Bowring")
	sh_bh_docks_hijack(checkpoint, is_restart)
end


function sh_bh_docks_hijack(checkpoint, is_restart)
	if (checkpoint == CHECKPOINT_START) then
		mission_start_fade_out()

		teleport_coop("sh_bh_docks_$nstart","sh_bh_docks_$nstart (0)")
		
		if (not is_restart) then
			cutscene_play(CUTSCENE_IN)
		else
			group_create_hidden("sh_bh_docks_$Ghijack")
		end
	
		notoriety_set_max("brotherhood", 0)
		notoriety_force_no_spawn("brotherhood", true)

		group_show("sh_bh_docks_$Ghijack")
		
		while group_is_loaded("sh_bh_docks_$Ghijack")==false  do
			thread_yield()
		end
	
		on_trigger("sh_bh_docks_roadblock" ,"sh_bh_docks_$troadblock")

		on_vehicle_enter("sh_bh_docks_hijack_handler", HIJACK_TRUCK)
		on_take_damage("sh_bh_docks_hijack_warning", HIJACK_TRUCK)
		on_vehicle_destroyed("sh_bh_docks_vehicle_destroyed_fail", HIJACK_TRUCK)

		objective_text_clear(0)
		mission_help_table("sh_bh_docks_instruct_one")
	
		marker_add_vehicle(HIJACK_TRUCK, MINIMAP_ICON_PROTECT_ACQUIRE, INGAME_EFFECT_VEHICLE_PROTECT_ACQUIRE)
	
		mission_start_fade_in()
	elseif (checkpoint == CHECKPOINT_ENTER) then
		mission_start_fade_out(0.0)

		notoriety_set_max("brotherhood", 0)
		notoriety_force_no_spawn("brotherhood", true)

		group_create("sh_bh_docks_$Ghijack", true)
		on_trigger("sh_bh_docks_roadblock", "sh_bh_docks_$troadblock")

		on_vehicle_enter("", HIJACK_TRUCK)
		on_take_damage("", HIJACK_TRUCK)
		on_vehicle_destroyed("", HIJACK_TRUCK)
		incar = true

		for i = 1, hijack_guards_total, 1 do
			character_kill(hijack_guards[i])	-- Destroy the guards
		end

		mission_start_fade_in()

		sh_bh_docks_convoy(LOCAL_PLAYER)
	elseif (checkpoint == CHECKPOINT_GETOUT) then
		mission_start_fade_out(0.0)

		group_create("sh_bh_docks_$Gconvoy", true)
		group_create("sh_bh_docks_$GCone", true)
		group_create("sh_bh_docks_$GCtwo", true)
		group_create("sh_bh_docks_$Gthree", true)

		vehicle_enter_group_teleport("sh_bh_docks_$c004", "sh_bh_docks_$c004 (0)", "sh_bh_docks_$c004 (1)", "sh_bh_docks_$c004 (2)", CONVOY_TRUCK)
		teleport_vehicle(CONVOY_TRUCK, "sh_bh_docks_$npath1")	-- Warp the vehicle to the destination

		convoy1 = true

		mission_start_fade_in()

		sh_bh_docks_getout()
	end

end

function sh_bh_docks_hijack_warning()
	
	if message_playing then
		return
	else
		message_playing=true
		mission_help_table_nag("sh_bh_docks_fail_warning_four")
		delay(10)
		message_playing=false  
	end
end


-- Truck Entered
function sh_bh_docks_hijack_handler(char)
	incar_timer=false
	incar=true
	mission_debug("hijackhandler="..hijackpeds_count)
	on_take_damage("", HIJACK_TRUCK)

	if (incar) then
		on_vehicle_destroyed("",HIJACK_TRUCK)
		objective_text_clear(0)
		sh_bh_docks_convoy(char)
	end
end

function sh_bh_docks_nodes(char, index)
local action_node

--function to put NPC into action nodes
--mission_debug("Nodes Used"..char..index)
 
if index == 1 then
	
	action_node = "BH_RandomAction"

	elseif index == 2 then

	action_node = "BH_DrinkBeer"

	elseif index == 3 then

	action_node = "Blunt_Smoker"

	else

	action_node = "BH_RandomAction"

	end	

mission_debug("Nodes Used"..action_node)
npc_use_closest_action_node_of_type(char, action_node,100)
end

function sh_bh_docks_get_back_in()
end

function sh_bh_docks_get_back()
end

function sh_bh_docks_get_back_fail()
end


function sh_bh_docks_killcount1(human)
end

function sh_bh_docks_convoy(human)
	if (not human == LOCAL_PLAYER) then
		mission_debug("returning")
		return	
	end

	if (g_checkpoint ~= CHECKPOINT_ENTER) then
		mission_set_checkpoint(CHECKPOINT_ENTER)	-- Checkpoint [nclok1405]
	end

	if (hijackpeds_count == hijackpeds_total) then
		objective_text_clear(0)
	end
		

	if (incar) then			
		mission_debug("convoy_begin")
		on_projectile_hit("sh_bh_docks_satchel")
		
		marker_remove_vehicle(HIJACK_TRUCK)
		on_vehicle_enter("", HIJACK_TRUCK)
		trigger_enable("sh_bh_docks_$troadblock", true)
		--Creating groups for later 
		mission_debug("creating groups")
		group_create("sh_bh_docks_$Gconvoy", true)
		group_create("sh_bh_docks_$GCone", true)
		group_create("sh_bh_docks_$GCtwo", true)
		group_create("sh_bh_docks_$Gthree", true)
		group_create("sh_bh_docks_$Graodblock", true)

		for i = 1, convoy_total, 1 do
			mission_debug("on death called")
			on_death("sh_bh_docks_vehicle_destroyed_fail_passenger", convoy[i])
		end
		on_vehicle_destroyed("sh_bh_docks_fail_convoy",CONVOY_TRUCK)
		vehicle_set_untowable(CONVOY_TRUCK, true)
		mission_debug("groups created")
		turn_invulnerable(CONVOY_TRUCK, false)
		--put guys in cars
		mission_debug("get yo ass in car")
		vehicle_enter_group_teleport("sh_bh_docks_$croad2", "sh_bh_docks_$croad2 (0)" , "sh_bh_docks_$v001 (2)")
		vehicle_enter_group_teleport("sh_bh_docks_$croad1", "sh_bh_docks_$croad1 (0)" , "sh_bh_docks_$v001 (3)")
		vehicle_enter_group_teleport("sh_bh_docks_$c004", "sh_bh_docks_$c004 (0)", "sh_bh_docks_$c004 (1)", "sh_bh_docks_$c004 (2)", CONVOY_TRUCK)
		--vehicle_enter_group_teleport("sh_bh_docks_$c004 (3)", "sh_bh_docks_$c004 (4)", "sh_bh_docks_$c004 (5)", "sh_bh_docks_$c004 (6)", "sh_bh_docks_$v001 (0)")
		--vehicle_enter_group_teleport("sh_bh_docks_$c005", "sh_bh_docks_$c005 (0)", "sh_bh_docks_$c005 (1)", "sh_bh_docks_$c005 (2)", "sh_bh_docks_$v001 (1)")
		for i = 1, follow_count, 1 do
			on_death("sh_bh_docks_vehicle_destroyed_fail_passenger",follow_car[i])
		end
		mission_debug("ass in cars")
		marker_add_vehicle(CONVOY_TRUCK, MINIMAP_ICON_PROTECT_ACQUIRE, INGAME_EFFECT_VEHICLE_PROTECT_ACQUIRE)		
		mission_debug("starting convoy")
		thread_new("sh_bh_docks_convoy1")
		mission_help_table("sh_bh_docks_instruct_three")
		delay(12)
		mission_help_table("sh_bh_docks_instruct_two")
		distance_display_on(CONVOY_TRUCK, 0, 60, 0, 60, SYNC_ALL) 
		on_tailing_too_far("sh_bh_docks_follow_bad") 
		on_tailing_good("sh_bh_docks_follow_good")		
		if(get_dist_char_to_vehicle(LOCAL_PLAYER,CONVOY_TRUCK) > 60) then
			sh_bh_docks_follow_bad()
		end
		if coop_is_active() then
			if(get_dist_char_to_vehicle(REMOTE_PLAYER,CONVOY_TRUCK) > 60) then
				sh_bh_docks_follow_bad()
			end
		end
		delay(.5)		
		while (not convoy1) do 
			thread_yield()
		end		
	else	
		return
	end	

	--mission_debug("done yeilding")
	if (convoy1) then
		hud_timer_stop(0) 
		on_projectile_hit("")
		marker_remove_vehicle(CONVOY_TRUCK)
		objective_text(0, "sh_bh_docks_gangleft",  convoy_count, convoy_total, SYNC_ALL)
		on_take_damage("", CONVOY_TRUCK) 
		on_tailing_too_far("") 
		on_tailing_good("")
		on_vehicle_destroyed("",CONVOY_TRUCK)		
	end	

	mission_set_checkpoint(CHECKPOINT_GETOUT)	-- Checkpoint [nclok1405]
	sh_bh_docks_getout()
end

--Give convoy infinite life (i.e. once at 50% he can never go below 50%)

function sh_bh_docks_convoy1()
	mission_debug("Convoy now")
	vehicle_set_allow_ram_ped(CONVOY_TRUCK, true) 
	vehicle_never_flatten_tires(CONVOY_TRUCK, true) 
	vehicle_set_script_hard_goto(CONVOY_TRUCK, true)
	on_take_damage("sh_bh_docks_fail_take_damage", CONVOY_TRUCK) 
	vehicle_ignore_repulsors(CONVOY_TRUCK, true)
	vehicle_infinite_mass(CONVOY_TRUCK, true)
	vehicle_speed_override(CONVOY_TRUCK, 50)
	vehicle_pathfind_to(CONVOY_TRUCK, "sh_bh_docks_$pathConvoy", true, false)
	vehicle_pathfind_to(CONVOY_TRUCK, "sh_bh_docks_$pathConvoy1", true, false)
	vehicle_pathfind_to(CONVOY_TRUCK, "sh_bh_docks_$pathconvoyint", true, false)
	vehicle_pathfind_to(CONVOY_TRUCK, "sh_bh_docks_$pathconvoyint1", true, false)
	vehicle_pathfind_to(CONVOY_TRUCK, "sh_bh_docks_$pathConvoy2", true, false)
	vehicle_pathfind_to(CONVOY_TRUCK, "sh_bh_docks_$npath1", true, true)
	hud_timer_stop(0)
	distance_display_off(SYNC_ALL)
	mission_debug("convoy true")
	convoy1=true
end


function sh_bh_docks_getout()
	objective_text_clear(0)
	mission_help_table("MSN_SH_BH_DOCKS_INSTRUCT_SIX")
	notoriety_set_max("brotherhood", 3)
	notoriety_force_no_spawn("brotherhood", false)
	mission_debug("getout")
	objective_text(0, "sh_bh_docks_gangleft",  convoy_count, convoy_total, SYNC_ALL)
	turn_invulnerable(CONVOY_TRUCK,true)

	for i = 1, convoy_total, 1 do
		if character_is_dead(convoy[i]) == false then
		on_death("sh_bh_docks_killcount", convoy[i])
		marker_add_npc(convoy[i], MINIMAP_ICON_KILL, INGAME_EFFECT_KILL)
		--no animations for big truck		
		--vehicle_exit(convoy[i], true)
		--attack(convoy[i], LOCAL_PLAYER)
		end
	end

	for i=1, convoy_one_total, 1 do	
		if character_is_dead(convoy_one[i])== false then
			thread_handles[i]=thread_new("sh_bh_docks_pathfind",convoy_one[i],convoy_one_navs[i])
		end
	end
end

function sh_bh_docks_pathfind(char_name, nav)
	vehicle_exit(char_name, true)
	npc_combat_enable(char_name, true) 		
	move_to_safe(char_name, nav, 2, false, false)
end

function sh_bh_docks_killcount(char)
	convoy_count = convoy_count + 1
	marker_remove_npc(char)
	if convoy1 then
		objective_text(0, "sh_bh_docks_gangleft",  convoy_count, convoy_total, SYNC_ALL)
	end
	if convoy_count == convoy_total then
		--debug_message("GROUP TWO")
		objective_text_clear(0)
		release_to_world("sh_bh_docks_$Gconvoy")
		--mission_set_checkpoint("boat")
		mission_end_success(MISSION_NAME)					
	end
	if convoy_count == 1 then
		notoriety_set_min("brotherhood", 3)
		notoriety_force_no_spawn("brotherhood", false) 	
	end
end

function sh_bh_docks_satchel(type, name, weapon)
--mission_debug("type=  "..type)
--mission_debug("name=  "..name)
--mission_debug("weapon=  "..weapon)

	if type == "vehicle" and name == CONVOY_TRUCK and weapon == "satchel" then
		mission_fail(MISSION_NAME,MISSION_FAIL_THREE)
	end

end


function sh_bh_docks_boat()
end


function sh_bh_docks_boat_killcount(char)
end

function sh_bh_docks_roadblock(char, trigger_name)

--mission_debug("char ="..char)

	if char == "sh_bh_docks_$c004 (2)" or "sh_bh_docks_$c004" or "sh_bh_docks_$c004 (0)" or "sh_bh_docks_$c004 (1)" or CONVOY_TRUCK then
		mission_debug("EXECUTE")
		--[[
		for i = 1, action_total, 1 do
			sh_bh_docks_nodes(action[i][1],action[i][2])
		end
		--]]
		vehicle_speed_override(CONVOY_TRUCK, 100)
		--mission_help_table_nag("sh_bh_docks_made_you")
		hud_timer_stop(0)
		delay(3)
		--thread_new("sh_bh_docks_roadblock_move_one")
		--thread_new("sh_bh_docks_roadblock_move_two")
		trigger_enable("sh_bh_docks_$troadblock", false)
		notoriety_set_max("brotherhood", 3)
		--`notoriety_set("brotherhood", 3)
		marker_remove_vehicle(CONVOY_TRUCK)
		distance_display_off(SYNC_ALL)
		on_vehicle_destroyed("",HIJACK_TRUCK)
		on_vehicle_destroyed("",CONVOY_TRUCK)
		on_take_damage("", CONVOY_TRUCK) 
		on_tailing_too_far("") 
		on_tailing_good("") 
		on_vehicle_exit("", HIJACK_TRUCK)
		on_vehicle_enter("", HIJACK_TRUCK)
	end
end

function sh_bh_docks_roadblock_move_one()
	vehicle_pathfind_to("sh_bh_docks_$v001 (2)", "sh_bh_docks_$nroad1", true, true)
	vehicle_exit("sh_bh_docks_$croad2")
	vehicle_exit("sh_bh_docks_$croad2 (0)") 
end


function sh_bh_docks_roadblock_move_two()
	vehicle_pathfind_to("sh_bh_docks_$v001 (3)", "sh_bh_docks_$nroad1 (0)", true, true)
	vehicle_exit("sh_bh_docks_$croad1")
	vehicle_exit("sh_bh_docks_$croad1 (0)") 
end


function sh_bh_docks_wave()
end



function sh_bh_docks_buyer_chase()
end




function sh_bh_docks_follow_bad()
	mission_help_table_nag("sh_bh_docks_warning_two")
	hud_timer_set(0,1000*20, "sh_bh_docks_fail_convoy") --, SYNC_ALL, true) 
end

function sh_bh_docks_follow_good()		
	hud_timer_stop(0) 	
end

function sh_bh_docks_vehicle_destroyed_fail()
	mission_fail(MISSION_NAME, MISSION_FAIL_FOUR) --You destroyed the truck!
end

function sh_bh_docks_vehicle_destroyed_fail_passenger()
	mission_fail(MISSION_NAME, MISSION_FAIL) --You destroyed the truck!
end

function sh_bh_docks_fail_convoy()
	mission_fail(MISSION_NAME,"sh_bh_docks_fail_two",0)
end

function sh_bh_docks_fail_take_damage(attacked_vehicle, attacker)
	
	if (attacker==LOCAL_PLAYER or attacker==REMOTE_PLAYER) then
		times_damaged = times_damaged + 1

		if times_damaged >= 3 then		
			mission_fail(MISSION_NAME,MISSION_FAIL_THREE)
		else
			mission_help_table_nag("sh_bh_docks_fail_warning_four")
		end
	end
end

function sh_bh_docks_cleanup()
	spawning_pedestrians(true, true)
	spawning_vehicles(true)
	set_traffic_density(1)
	set_ped_density(1)

	--turn_invulnerable("sh_bh_docks_$vplayerwave", false)
	--release_to_world("sh_bh_docks_$vplayerwave")
	marker_remove_vehicle(HIJACK_TRUCK)
	marker_remove_vehicle("sh_bh_docks_$v002")
	on_tailing_too_far("") 
	on_tailing_good("") 
	on_vehicle_enter("", "sh_bh_docks_$vplayerwave")
	on_take_damage("", CONVOY_TRUCK)
	on_vehicle_enter("", HIJACK_TRUCK) 
	on_take_damage("", HIJACK_TRUCK) 
	on_trigger("" ,"sh_bh_docks_$troadblock")
	on_projectile_hit("")
	distance_display_off() 
	on_tailing_too_far("") 
	on_tailing_good("")
	on_vehicle_destroyed("",CONVOY_TRUCK)
	hud_timer_stop(0)
	for i = 1, convoy_total, 1 do
		if group_is_loaded("sh_bh_docks_$GCtwo") then
			if character_is_dead(convoy[i]) == false then
				on_death("", convoy[i])
				marker_remove_npc(convoy[i])
			end
		end
	end

	if group_is_loaded("sh_bh_docks_$GCone") then
		group_destroy("sh_bh_docks_$GCone")
	end
	
	if group_is_loaded("sh_bh_docks_$GCtwo") then
		group_destroy("sh_bh_docks_$GCtwo")
	end

	if group_is_loaded("sh_bh_docks_$GCthree") then
		group_destroy("sh_bh_docks_$GCthree")
	end


end



function sh_bh_docks_success()



end



function sh_bh_docks_timer()
	--hud_timer_pause(0, true)
	--hud_timer_set(0, 15000, "sh_bh_chinatown_timeout") 
	incar_timer=false
	incar_timer_coop=false
		
	if coop_is_active() then
		if char == REMOTE_PLAYER then
			in_areatwo = false
		end
	end

	local time = 0
	local messone = true
	local messtwo = true	
	mission_debug("LEAVE")
	--mission_debug(in_area)

	if coop_is_active() then
		while(incar_timer==false and incar_timer_coop==false) do
			
			time = time + get_frame_time()

			if(incar_timer==true and incar_timer_coop==false) then
				return
			end

			if (time > 15) then					
				mission_help_table_nag("MSN_SH_BH_DOCKS_WARNING_ONE")
			end
			
			if (time > 10) then				
				if (messone == true) then
					mission_help_table_nag("MSN_SH_BH_DOCKS_WARNING_THREE_TIMER")
					messone = false
				end
			end


			if (time > 5) then
				-- Second message (10 seconds left)
				if (messtwo == true) then
					mission_help_table_nag("MSN_SH_BH_DOCKS_WARNING_TWO_TIMER")						
					messtwo = false
				end				
			end
			
			if (time == 0) then
				-- Fail if timer runs out
				if (messtwo == true) then
					--put fail function here	
					messtwo = false
				end				
			end

			thread_yield()	
		end				
	else
		while(incar_timer==false) do
			
			time = time + get_frame_time()

			if(incar_timer==true) then
				return
			end

			if (time > 15) then					
				--mission_help_table_nag("sh_bh_chinatown_warning_one")
				mission_help_table_nag("MSN_SH_BH_DOCKS_WARNING_ONE")		
			end				

			if (time > 10) then				
				if (messone == true) then
					mission_help_table_nag("MSN_SH_BH_DOCKS_WARNING_THREE_TIMER")
					messone = false
				end
			end

			if (time > 5) then
				-- Second message (10 seconds left)
				if (messtwo == true) then
					mission_help_table_nag("MSN_SH_BH_DOCKS_WARNING_TWO_TIMER")
					messtwo = false
				end
			end

			if (time == 0) then
				-- Fail if timer runs out
				if (messtwo == true) then
					messtwo = false
				end				
			end

			thread_yield()
		end				
	end
	--hud_timer_hide(0, true) 		
	--hud_timer_stop(0, true)				
end
