-- sh_rn_museum_pier.lua: Amberbrook Museum Pier
-- Cutscene crash fixes by IdolNinja
-- 3/12/2011

-- Checkpoint Variables [nclok1405]
g_checkpoint = MISSION_START_CHECKPOINT	-- Checkpoint name [nclok1405]
g_is_restart = false	-- true if restarting [nclok1405]

-- Checkpoints [nclok1405]
CHECKPOINT_START = MISSION_START_CHECKPOINT
CHECKPOINT_0 = "CHECKPOINT_0"	-- Kill one member of the first group
CHECKPOINT_1 = "CHECKPOINT_1"	-- First group destroyed
CHECKPOINT_1A = "CHECKPOINT_1A"	-- Second group reached
CHECKPOINT_2 = "CHECKPOINT_2"	-- Second group destroyed
CHECKPOINT_2A = "CHECKPOINT_2A"	-- Boat

-- Important Group Names [nclok1405]
RONIN_GROUP_ONE = "sh_rn_museum_pier_$GO"
RONIN_GROUP_TWO = "sh_rn_museum_pier_$Gt"
RONIN_GROUP_THREE = "sh_rn_museum_pier_$Gb"
RONIN_GROUP_BOATS = "sh_rn_museum_pier_$Gboats"
RONIN_GROUP_MISC = "sh_rn_museum_pier_$GRoad"
RONIN_GROUP_HELI = "sh_rn_museum_pier_$Gchopper"

NAVPOINT_LOCAL_PLAYER_START  = "sh_rn_museum_pier_$nstart"
NAVPOINT_REMOTE_PLAYER_START = "sh_rn_museum_pier_$nstart2"

-- Tables
GroupOne = {"sh_rn_museum_pier_$c000", "sh_rn_museum_pier_$c001", "sh_rn_museum_pier_$c002", "sh_rn_museum_pier_$c003", "sh_rn_museum_pier_$c004", "sh_rn_museum_pier_$c005", "sh_rn_museum_pier_$c006", "sh_rn_museum_pier_$c007", "sh_rn_museum_pier_$c008"}    
GroupTwo = {"sh_rn_museum_pier_$c010", "sh_rn_museum_pier_$c011", "sh_rn_museum_pier_$c012", "sh_rn_museum_pier_$c013", "sh_rn_museum_pier_$c014", "sh_rn_museum_pier_$c015", "sh_rn_museum_pier_$c016", "sh_rn_museum_pier_$c017", "sh_rn_museum_pier_$c018", "sh_rn_museum_pier_$c019"}
GroupThree = {"sh_rn_museum_pier_$c023", "sh_rn_museum_pier_$c022", "sh_rn_museum_pier_$c021", "sh_rn_museum_pier_$c020"}
GroupBoats ={"sh_rn_museum_pier_$v000", "sh_rn_museum_pier_$v001", "sh_rn_museum_pier_$v002", "sh_rn_museum_pier_$v003", "sh_rn_museum_pier_$v004"}
Groups = {RONIN_GROUP_ONE, RONIN_GROUP_TWO, RONIN_GROUP_THREE, RONIN_GROUP_BOATS, RONIN_GROUP_MISC, RONIN_GROUP_HELI}
helipath = {"sh_rn_museum_pier_$n005", "sh_rn_museum_pier_$n006", "sh_rn_museum_pier_$n007", "sh_rn_museum_pier_$n008", "sh_rn_museum_pier_$n009", "sh_rn_museum_pier_$n010", "sh_rn_museum_pier_$n011", "sh_rn_museum_pier_$n012", "sh_rn_museum_pier_$n013", "sh_rn_museum_pier_$n014", "sh_rn_museum_pier_$n015"}
boatguards = {"sh_rn_museum_pier_$c024", "sh_rn_museum_pier_$c025", "sh_rn_museum_pier_$c026", "sh_rn_museum_pier_$c027", "sh_rn_museum_pier_$c028", "sh_rn_museum_pier_$c029", "sh_rn_museum_pier_$c032", "sh_rn_museum_pier_$c033", "sh_rn_museum_pier_$c034", "sh_rn_museum_pier_$c036"}
--Global Vaiables
GroupOneCount = 0
GroupOneTotal = sizeof_table( GroupOne )
GroupTwoCount = 0
GroupTwoTotal = sizeof_table( GroupTwo )
GroupBoatsCount = 0
GroupBoatsTotal = sizeof_table( GroupBoats )
GroupsTotal = sizeof_table( Groups )
boatguardscount =0
boatguardstotal = sizeof_table( boatguards )
areatwo = false
areathree = false
BoatCheckpointSet = false

-- CUTSCENES --
-- Added by IdolNinja. These variables are used in the script for the cutscenes for stability instead of calling them directly

	CUTSCENE_IN = 		"sh_rn_museum_piercs3"
	MISSION_NAME =		"sh_rn_museum_pier"

--- Start Function
function sh_rn_museum_pier_start(checkpoint, is_restart)
	-- Remember the checkpoint and restart values [nclok1405]
	g_checkpoint = checkpoint
	g_is_restart = is_restart

	set_mission_author("David Bowring")

	-- Fade out
	mission_start_fade_out()

	-- Disable Spawns
	character_slots_cap_for_team("police", 0)
	notoriety_set_max("police", 0)
	ambient_cop_spawn_enable(false)
	ambient_gang_spawn_enable(false) 
	spawning_pedestrians(false) 

	if (checkpoint == CHECKPOINT_START) then
		-- Cap Ronin Notoriety to 0 until the mission really starts
		notoriety_set_max("ronin", 0)

		-- Teleport player(s) to starting location
		teleport_coop(NAVPOINT_LOCAL_PLAYER_START, NAVPOINT_REMOTE_PLAYER_START)
	end

	-- Load Groups
	-- The original script had "added delay to make more network friendly" but
	-- other missions do not insert such delay at the beginning of the mission, so I removed them.
	-- Hopefully it works just like as normal missions... [nclok1405]
	local spawnGroupOne = ((checkpoint == CHECKPOINT_START) or (checkpoint == CHECKPOINT_0))
	local spawnGroupTwo = ((checkpoint == CHECKPOINT_START) or (checkpoint == CHECKPOINT_0) or (checkpoint == CHECKPOINT_1) or (checkpoint == CHECKPOINT_1A))
	
	local group_list = {RONIN_GROUP_THREE, RONIN_GROUP_BOATS, RONIN_GROUP_MISC}
	if spawnGroupOne then
		group_list[sizeof_table(group_list) + 1] = RONIN_GROUP_ONE
	end
	if spawnGroupTwo then
		group_list[sizeof_table(group_list) + 1] = RONIN_GROUP_TWO
	end
	
	if (checkpoint == CHECKPOINT_START) and (not is_restart) then
		-- Play Intro Cutscene
		cutscene_play( CUTSCENE_IN, group_list, {NAVPOINT_LOCAL_PLAYER_START, NAVPOINT_REMOTE_PLAYER_START}, false )
		
		-- Unload Cutscene Characters
		group_destroy("sh_rn_museum_pier_$GCTE")
		
		-- cutscene_play creates hidden groups, make sure that we show them.
		for i,group in pairs(group_list) do
			group_show(group)
		end
	else
		-- Create groups
		for i,group in pairs(group_list) do
			group_create(group, true)
		end
	end

	if (spawnGroupOne) then
		for i = 1, GroupOneTotal, 1 do
			on_death("sh_rn_museum_pier_killcount", GroupOne[i])
			set_always_sees_player_flag(GroupOne[i], true)
		end
	end
	if (spawnGroupTwo) then
		for i = 1, GroupTwoTotal, 1 do
			if not character_is_dead(GroupTwo[i]) then
				on_death("sh_rn_museum_pier_killcountTwo", GroupTwo[i])
				wander_start(GroupTwo[i], GroupTwo[i], 10)
			end
		end
	end

	for i = 1, GroupBoatsTotal, 1 do
		if not vehicle_is_destroyed(GroupBoats[i]) then
			set_current_hit_points( GroupBoats[i], 1000) 
			turn_invulnerable(GroupBoats[i], true)
			on_vehicle_destroyed("sh_rn_museum_pier_killcountThree", GroupBoats[i])
		end
	end

	-- If coop, load the heli
	if is_coop_difficulty() then
		group_create_hidden(RONIN_GROUP_HELI)
	end

	on_trigger("sh_rn_museum_pier_areaone", "sh_rn_museum_pier_$tareaone")
	on_trigger("sh_rn_museum_pier_areatwo", "sh_rn_museum_pier_$tareatwo")
	on_trigger("sh_rn_museum_pier_areathree", "sh_rn_museum_pier_$tareathree")

	mission_start_fade_in()
	-- Fade In

	if (checkpoint == CHECKPOINT_START) or (checkpoint == CHECKPOINT_0) then
		marker_add_navpoint("sh_rn_museum_pier_$tareaone", MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
		trigger_enable("sh_rn_museum_pier_$tareaone", true)

		-- Intro Text
		if (not is_restart) then
			mission_help_table_nag("sh_rn_museum_pier_setup")
			delay(3)
		end

		mission_help_table("sh_rn_museum_pier_instructtwo")
	elseif (checkpoint == CHECKPOINT_1) or (checkpoint == CHECKPOINT_1A) then
		areatwo = true
		mission_help_table("sh_rn_museum_pier_instructone")
		marker_add_navpoint("sh_rn_museum_pier_$tareatwo", MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)			
		trigger_enable("sh_rn_museum_pier_$tareatwo", true)
	elseif (checkpoint == CHECKPOINT_2) or (checkpoint == CHECKPOINT_2A) then
		areathree = true
		mission_help_table("sh_rn_museum_pier_instructthree")
		marker_add_navpoint("sh_rn_museum_pier_$tareathree", MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
		trigger_enable("sh_rn_museum_pier_$tareathree", true)
		
		-- Spawn Heli in coop
		if is_coop_difficulty() then
			thread_new("sh_rn_museum_pier_heli")
		end
	end
end

function sh_rn_museum_pier_areaone()
	notoriety_set_max("ronin", 2)
	notoriety_set_min("ronin", 2)
	objective_text(0, "sh_rn_museum_pier_GroupOneCount",   GroupOneCount, GroupOneTotal)
	trigger_enable("sh_rn_museum_pier_$tareaone", false)
	marker_remove_navpoint("sh_rn_museum_pier_$tareaone")
	for i = 1, GroupOneTotal, 1 do
		marker_add_npc(GroupOne[i], MINIMAP_ICON_KILL, INGAME_EFFECT_KILL)
		attack(GroupOne[i], LOCAL_PLAYER)
	end
end

function sh_rn_museum_pier_areatwo()
	-- Spawn Heli in coop
	if is_coop_difficulty() then
		thread_new("sh_rn_museum_pier_heli")
	end

	objective_text_clear(0)
	
	areatwo=true
	if (GroupTwoCount == GroupTwoTotal)  and areatwo then
		--debug_message("GROUP TWO")
		release_to_world(RONIN_GROUP_TWO)
		marker_add_navpoint("sh_rn_museum_pier_$tareathree", MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
		trigger_enable("sh_rn_museum_pier_$tareathree", true)
		objective_text_clear(0)
		areathree=true
	end
	
	if areatwo then
		sh_rn_museum_pier_group_two()
	elseif areathree then
		sh_rn_museum_pier_areathree()
	end
end

function sh_rn_museum_pier_areathree()
	objective_text_clear(0)
	areathree=true
	trigger_enable("sh_rn_museum_pier_$tareathree", false)
	mission_debug("remove navpoint")
	marker_remove_navpoint("sh_rn_museum_pier_$tareathree")
	
	if GroupBoatsCount == GroupBoatsTotal and areathree then
		--debug_message("GROUP TWO")
		release_to_world(RONIN_GROUP_THREE)
		--sh_rn_museum_pier_group_three()
		--delay(3)
		mission_end_success(MISSION_NAME) 
		--sh_rn_museum_pier_group_Four()
	end

	sh_rn_museum_pier_group_three()
end

function sh_rn_museum_pier_killcount(char)
	GroupOneCount = GroupOneCount + 1
	
	marker_remove_npc(char)
	objective_text(0, "sh_rn_museum_pier_GroupOneCount",  GroupOneCount, GroupOneTotal)
	notoriety_set_max("police", 0)

	if GroupOneCount == GroupOneTotal then
		--debug_message("GROUP TWO")
		release_to_world(RONIN_GROUP_ONE)
		marker_add_navpoint("sh_rn_museum_pier_$tareatwo", MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)			
		mission_help_table("sh_rn_museum_pier_instructone")
		objective_text_clear(0)
		areatwo = true
		trigger_enable("sh_rn_museum_pier_$tareatwo", true)
		mission_set_checkpoint(CHECKPOINT_1)	-- Checkpoint [nclok1405]
	end

	if (GroupOneCount == 1) then
		for i = 1, GroupOneTotal, 1 do
			set_always_sees_player_flag(GroupOne[i], true)
			attack(GroupOne[i], LOCAL_PLAYER)
		end

		if (g_checkpoint ~= CHECKPOINT_0) then
			mission_set_checkpoint(CHECKPOINT_0)	-- Checkpoint [nclok1405]
		end
	end
end

function sh_rn_museum_pier_group_two()
	if (g_checkpoint ~= CHECKPOINT_1A) then
		mission_set_checkpoint(CHECKPOINT_1A)	-- Checkpoint [nclok1405]
	end

	trigger_enable("sh_rn_museum_pier_$tareatwo", false)
	marker_remove_navpoint("sh_rn_museum_pier_$tareatwo")
	objective_text_clear(0)
	--group_create(RONIN_GROUP_TWO, true)
	
	if (GroupTwoCount == GroupTwoTotal)  and areatwo then
		--debug_message("GROUP TWO")
		release_to_world(RONIN_GROUP_TWO)
		marker_add_navpoint("sh_rn_museum_pier_$tareathree", MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
		trigger_enable("sh_rn_museum_pier_$tareathree", true)
		objective_text_clear(0)
		areathree=true
	end
	
	objective_text(0, "sh_rn_museum_pier_GroupTwoCount", GroupTwoCount, GroupTwoTotal)

	for i = 1, GroupTwoTotal, 1 do
		if not character_is_dead(GroupTwo[i]) then
			marker_add_npc(GroupTwo[i], MINIMAP_ICON_KILL, INGAME_EFFECT_KILL)
			on_death("sh_rn_museum_pier_killcountTwo", GroupTwo[i])
		end
	end
	
 	notoriety_set_max("ronin", 2)
	notoriety_set_min("ronin", 2)
end

function sh_rn_museum_pier_killcountTwo(char)
	GroupTwoCount = GroupTwoCount + 1
	
	if areatwo then
		marker_remove_npc(char)
		objective_text(0, "sh_rn_museum_pier_GroupTwoCount", GroupTwoCount, GroupTwoTotal)
	end
	
	if (GroupTwoCount == GroupTwoTotal)  and areatwo then
		--debug_message("GROUP TWO")
		release_to_world(RONIN_GROUP_TWO)
		trigger_enable("sh_rn_museum_pier_$tareathree", true)
		objective_text_clear(0)
		areathree=true
		mission_help_table("sh_rn_museum_pier_instructthree")
		mission_set_checkpoint(CHECKPOINT_2)	-- Checkpoint [nclok1405]
	end
end

function sh_rn_museum_pier_group_three()
	--delay(3)

	if areathree then
		mission_help_table_nag("sh_rn_museum_pier_instructthree")
		objective_text(0, "sh_rn_museum_pier_GroupThreeCount",  GroupBoatsCount, GroupBoatsTotal )
	end

	marker_remove_navpoint("sh_rn_museum_pier_$tareathree")

	if GroupBoatsCount == GroupBoatsTotal and areathree then
		--debug_message("GROUP TWO")
		release_to_world(RONIN_GROUP_THREE)
		--delay(3)
		mission_end_success(MISSION_NAME) 
	end
		
	for i = 1, boatguardstotal, 1 do			
		if character_is_dead(boatguards[i])==false then 
			on_death( "sh_rn_museum_pier_boatguards", boatguards[i])
		end
	end

	for i = 1, GroupBoatsTotal, 1 do
		if not vehicle_is_destroyed(GroupBoats[i]) then
			marker_add_vehicle(GroupBoats[i], MINIMAP_ICON_KILL, INGAME_EFFECT_VEHICLE_KILL)
			set_current_hit_points( GroupBoats[i], 1000) 
			turn_invulnerable(GroupBoats[i], true)
			--attack(GroupBoats[i], "#PLAYER#") 
			on_vehicle_destroyed("sh_rn_museum_pier_killcountThree", GroupBoats[i])
		end
	end
end

function sh_rn_museum_pier_boatguards(char)
	boatguardscount = boatguardscount + 1
	
	-- Make the boat guards attack the players
	if boatguardscount == 1 then
		for i = 1, boatguardstotal, 1 do
			if not character_is_dead(boatguards[i]) then
				set_always_sees_player_flag(boatguards[i], true)
				attack(boatguards[i])
			end
		end
	end
end

function sh_rn_museum_pier_killcountThree(vehicle)
	GroupBoatsCount = GroupBoatsCount + 1
	
	if areathree then
		marker_remove_vehicle(vehicle)
		objective_text(0, "sh_rn_museum_pier_GroupThreeCount",  GroupBoatsCount, GroupBoatsTotal )

		if (g_checkpoint ~= CHECKPOINT_2A) and (not BoatCheckpointSet) then
			mission_set_checkpoint(CHECKPOINT_2A)	-- Checkpoint [nclok1405]
			BoatCheckpointSet = true	-- Do not set the same checkpoint twice
		end
	end

	if GroupBoatsCount == GroupBoatsTotal and areathree then
		--debug_message("GROUP TWO")
		release_to_world(RONIN_GROUP_THREE)
		--sh_rn_museum_pier_group_three()
		--delay(3)
		mission_end_success(MISSION_NAME)
		--sh_rn_museum_pier_group_Four()			
	end
end

function sh_rn_museum_pier_success()
end

function sh_rn_museum_pier_heli()
	--group_create(RONIN_GROUP_HELI)
	while not group_is_loaded(RONIN_GROUP_HELI) do
		-- Wait until the heli is loaded [nclok1405]
		thread_yield()
	end
	group_show(RONIN_GROUP_HELI)
	vehicle_enter_teleport("sh_rn_museum_pier_$c031", "sh_rn_museum_pier_$v006", 0)
	vehicle_enter_teleport("sh_rn_museum_pier_$c031 (0)", "sh_rn_museum_pier_$v006", 2)
	helicopter_fly_to("sh_rn_museum_pier_$v006", helipath)
	vehicle_chase("sh_rn_museum_pier_$v006", LOCAL_PLAYER)
end

function sh_rn_museum_pier_cleanup()
	notoriety_set_min("police", 0)
	notoriety_set_max("police", 5)
	notoriety_set_min("ronin", 0)
	notoriety_set_max("ronin", 5)
	notoriety_set("ronin", 0)	
	notoriety_force_no_spawn("ronin", false) 
	ambient_cop_spawn_enable(true) 
	ambient_gang_spawn_enable(true) 
	spawning_pedestrians(true)
	trigger_enable("sh_rn_museum_pier_$tareaone", false)
	trigger_enable("sh_rn_museum_pier_$tareatwo", false)
	trigger_enable("sh_rn_museum_pier_$tareathree", false)
	on_trigger("", "sh_rn_museum_pier_$tareaone")
	on_trigger("", "sh_rn_museum_pier_$tareatwo")
	on_trigger("", "sh_rn_museum_pier_$tareathree")
	marker_remove_navpoint("sh_rn_museum_pier_$tareaone")
	marker_remove_navpoint("sh_rn_museum_pier_$tareatwo")
	marker_remove_navpoint("sh_rn_museum_pier_$tareathree")
	
	if(group_is_loaded(RONIN_GROUP_ONE)) then
		for i = 1, GroupOneTotal, 1 do
			marker_remove_npc(GroupOne[i])
			on_death("", GroupOne[i])
		end
	end

	if(group_is_loaded(RONIN_GROUP_TWO)) then
		for i = 1, GroupTwoTotal, 1 do
			marker_remove_npc(GroupTwo[i])
			on_death("", GroupTwo[i])  
		end
	end

	if(group_is_loaded(RONIN_GROUP_BOATS)) then
		for i = 1, GroupBoatsTotal, 1 do
			marker_remove_vehicle(GroupBoats[i])
			on_vehicle_destroyed("", GroupBoats[i])  
		end
	end	
	
	for i = 1, GroupsTotal, 1 do		
		if(group_is_loaded(Groups[i])) then		
			release_to_world(Groups[i])		
		end
	end
end
