-- sh_tss_caverns.lua: Stilwater Caverns
-- It seems this mission went major changes during development.
-- There were a lot of unused codes and phase names are out of order... [nclok1405]

-- Triggers [nclok1405]
TRIGGER_FOUR = "sh_tss_caverns_$tBreadcrumb3"
TRIGGER_FIVE = "sh_tss_caverns_$tBreadcrumb4"
TRIGGER_PHASE_TWO_BC5 = "sh_tss_caverns_$tBreadcrumb5"
TRIGGER_PHASE_TWO_WW1 = "sh_tss_caverns_$twaterway1"
TRIGGER_PHASE_TWO_WW2 = "sh_tss_caverns_$twaterway2"

-- Checkpoint Names [nclok1405]
CHECKPOINT_PHASE_TWO = "phase_two"

-- Checkpoint Variables [nclok1405]
g_checkpoint = MISSION_START_CHECKPOINT	-- Checkpoint name [nclok1405]
g_is_restart = false	-- true if restarting [nclok1405]

CUTSCENE_IN = "sh_tss_caverns_ct1"	-- Intro Cutscene [nclok1405]

--Tables--

ShantiesTwo ={"sh_tss_caverns_CV_H1_shanty_030", "sh_tss_caverns_CV_H1_shanty_070", "sh_tss_caverns_CV_H1_shanty_040", "sh_tss_caverns_CV_H1_shanty_080", "sh_tss_caverns_CV_H1_shanty_060", "sh_tss_caverns_CV_H1_shanty_050"} 

	---Global variables--
Shantie_Two_Count = 0
Shantie_Two_Count_Total =sizeof_table( ShantiesTwo )
   
function sh_tss_caverns_start(checkpoint, is_restart)
	-- Remember the checkpoint and restart values [nclok1405]
	g_checkpoint = checkpoint
	g_is_restart = is_restart

	set_mission_author("David Bowring")

	-- Fade Start
	mission_start_fade_out()

	-- Teleport and cutscene on start
	if (checkpoint == MISSION_START_CHECKPOINT) then
		teleport_coop("sh_tss_caverns_$nstart","sh_tss_caverns_$nstart (0)")

		if (not is_restart) then
			cutscene_play(CUTSCENE_IN)
		end
	end

	notoriety_set("police", 0)	-- Remove Police Notoriety
	set_time_of_day(12, 00)	-- Lock Time of Day

	-- Replace Peds with Bums
	spawning_pedestrians(false)
	spawn_override_set_category("SH - UGCaverns - Bums")
	spawning_pedestrians(true)
	group_create("sh_tss_caverns_$GWave")

	-- Triggers
	on_trigger("sh_tss_caverns_breadcrumb_four", TRIGGER_FOUR)
	on_trigger("sh_tss_caverns_breadcrumb_five", TRIGGER_FIVE)
	on_trigger("sh_tss_caverns_phase_two", TRIGGER_PHASE_TWO_BC5)
	on_trigger("sh_tss_caverns_phase_two", TRIGGER_PHASE_TWO_WW1)
	on_trigger("sh_tss_caverns_phase_two", TRIGGER_PHASE_TWO_WW2)

	mission_start_fade_in()
	-- Fade End

	if (checkpoint == MISSION_START_CHECKPOINT) then
		trigger_enable(TRIGGER_PHASE_TWO_WW1, true)
		trigger_enable(TRIGGER_PHASE_TWO_WW2, true)

		mission_help_table("sh_tss_caverns_setup") 
		sh_tss_caverns_breadcrumb_start()
	elseif (checkpoint == CHECKPOINT_PHASE_TWO) then
		sh_tss_caverns_breadcrumb_start()
		sh_tss_caverns_phase_two()
	end
end

	---CutScene---
function sh_tss_caverns_phonecall()
end

function sh_tss_caverns_damage_sort(object, damager)
	local shack_hp = get_max_hit_points(object)
	if damager == LOCAL_PLAYER or damager == REMOTE_PLAYER then
		return
	else
		set_current_hit_points(object, shack_hp) 
	end
end         


	-----Lead player to the second set of shanties
function sh_tss_caverns_breadcrumb_start()
	group_create("sh_tss_caverns_$GRandom")
	force_throw_char("sh_tss_caverns_$c002 (0)","#PLAYER#", 45, 4)

	--trigger_enable(TRIGGER_THREE, true)
	--marker_add_trigger(TRIGGER_THREE, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)

	for i = 1, Shantie_Two_Count_Total, 1 do
		on_mover_destroyed("sh_tss_caverns__killcountTwo", ShantiesTwo[i])
	end

	trigger_enable(TRIGGER_FOUR, true)
	marker_add_trigger(TRIGGER_FOUR, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
end

function sh_tss_caverns_breadcrumb_four()
	--marker_remove_trigger(TRIGGER_FOUR)
	trigger_enable(TRIGGER_FOUR, false)
	trigger_enable(TRIGGER_FIVE, true)
	marker_add_trigger(TRIGGER_FIVE, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
end

function sh_tss_caverns_breadcrumb_five()
	marker_remove_trigger(TRIGGER_FIVE)
	trigger_enable(TRIGGER_FIVE, false)
	trigger_enable(TRIGGER_PHASE_TWO_BC5, true)
	marker_add_trigger(TRIGGER_PHASE_TWO_BC5, MINIMAP_ICON_LOCATION, INGAME_EFFECT_LOCATION)
	group_create("sh_tss_caverns_$GroupTwo")
	--release_to_world("sh_tss_caverns_$GroupTwo")
end



	----Second Goal - Destroy Shanties in area two ---
-- Confusingly, this is the real first phase [nclok1405]
function sh_tss_caverns_phase_two()
	if (g_checkpoint == MISSION_START_CHECKPOINT) then
		mission_set_checkpoint(CHECKPOINT_PHASE_TWO)	-- Checkpoint [nclok1405]
	end

	if group_is_loaded("sh_tss_caverns_$GroupTwo") == false then
		group_create("sh_tss_caverns_$GroupTwo")
	end
	marker_remove_trigger(TRIGGER_PHASE_TWO_BC5)
	trigger_enable(TRIGGER_PHASE_TWO_BC5, false)
	trigger_enable(TRIGGER_FIVE, false)
	trigger_enable(TRIGGER_FOUR, false)
	mission_debug("PHASE ONE", 5)
	notoriety_set("police", 0)
	on_trigger("", TRIGGER_PHASE_TWO_WW1)
	on_trigger("", TRIGGER_PHASE_TWO_WW2)
	on_trigger("", TRIGGER_FOUR)
	on_trigger("", TRIGGER_FIVE)
	on_trigger("", TRIGGER_PHASE_TWO_BC5)
	trigger_enable( TRIGGER_PHASE_TWO_WW1, false)
	trigger_enable( TRIGGER_PHASE_TWO_WW2, false)
	mission_help_table("sh_tss_caverns_Instruct_One")	
	objective_text(0, "sh_tss_caverns_Shanties_left",Shantie_Two_Count, Shantie_Two_Count_Total )

	for i = 1, Shantie_Two_Count_Total, 1 do
	  	marker_add_mover(ShantiesTwo[i], MINIMAP_ICON_KILL, INGAME_EFFECT_KILL)
		on_take_damage("sh_tss_caverns_damage_sort", ShantiesTwo[i])
		mission_debug("on take damage set="..ShantiesTwo[i])
		--on_mover_destroyed("sh_tss_caverns__killcountTwo", ShantiesTwo[i])
	end
end

	
function sh_tss_caverns__killcountTwo(mesh)

	Shantie_Two_Count = Shantie_Two_Count + 1
	marker_remove_mover(mesh)
	objective_text(0, "sh_tss_caverns_Shanties_left",Shantie_Two_Count, Shantie_Two_Count_Total )
	if (Shantie_Two_Count == Shantie_Two_Count_Total) then
		objective_text_clear(0)
		--delay(3)
		sh_tss_caverns_end()
	end

end

function sh_tss_caverns_success()
	teleport_coop( "sh_tss_caverns_$nend","sh_tss_caverns_$nend (0)"  )
end

function sh_tss_caverns_cleanup()
	spawn_override_set_category("")
	spawning_pedestrians(true)
	on_trigger("", TRIGGER_PHASE_TWO_WW1)
	on_trigger("", TRIGGER_PHASE_TWO_WW2)
	trigger_enable(TRIGGER_PHASE_TWO_WW1, false)
	trigger_enable(TRIGGER_PHASE_TWO_WW2, false)
	trigger_enable(TRIGGER_PHASE_TWO_BC5, false)
	trigger_enable(TRIGGER_FIVE, false)
	trigger_enable(TRIGGER_FOUR, false)
	on_trigger("", TRIGGER_FOUR)
	on_trigger("", TRIGGER_FIVE)
	on_trigger("", TRIGGER_PHASE_TWO_BC5)
	marker_remove_trigger(TRIGGER_FIVE)
	marker_remove_trigger(TRIGGER_PHASE_TWO_BC5)
	marker_remove_trigger(TRIGGER_FOUR)
end

function sh_tss_caverns_failure()
end

function sh_tss_caverns_end()
	mission_end_success("sh_tss_caverns")
end
